/******************************************************************************
 *                                     __                                     *
 *                              <-----/@@\----->                              *
 *                             <-< <  \\//  > >->                             *
 *                               <-<-\ __ /->->                               *
 *                               Data /  \ Crow                               *
 *                                   ^    ^                                   *
 *                       (c) 2003 Robert-Jan van der Waals                    *
 *                             rwaals@anytimenow.com                          *
 *                                                                            *
 *                                                                            *
 *       This library is free software; you can redistribute it and/or        *
 *        modify it under the terms of the GNU Lesser General Public          *
 *       License as published by the Free Software Foundation; either         *
 *     version 2.1 of the License, or (at your option) any later version.     *
 *                                                                            *
 *      This library is distributed in the hope that it will be useful,       *
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU       *
 *           Lesser General Public License for more details.                  *
 *                                                                            *
 *     You should have received a copy of the GNU Lesser General Public       *
 *    License along with this library; if not, write to the Free Software     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA   *
 *                                                                            *
 ******************************************************************************/

package rjw.apps.organizemp3;

import java.util.ResourceBundle;

import rjw.dc.resources.DCLabels;
import rjw.dc.resources.DCMessages;
import rjw.dc.resources.DCTooltips;
import rjw.dc.settings.SettingInitializator;
import rjw.dc.util.ModularResourceBundle;
import rjw.dc.util.Resources;

/**
 * Main class for the Organize MP3 module
 *
 * @author Robert-Jan van der Waals
 * @since 1.4
 * @version 0.1
 */
public class OrganizeMp3 {

    /**
     * Opens the Organize MP3 dialog. Arguments are ignored
     */
    public static void main(String[] args) {
        Resources.addTextResourceBundle((ModularResourceBundle) ResourceBundle.getBundle(DCTooltips.class.getName()));
        Resources.addTextResourceBundle((ModularResourceBundle) ResourceBundle.getBundle(DCLabels.class.getName()));
        Resources.addTextResourceBundle((ModularResourceBundle) ResourceBundle.getBundle(DCMessages.class.getName()));
        new SettingInitializator();
        
        OrganizeMp3UI organizeMP3UI = new OrganizeMp3UI();
        organizeMP3UI.show();
    }
}
