/*
 * Created on Dec 29, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package rjw.dc.console;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import rjw.dc.console.components.ComponentFactory;
import rjw.dc.core.Repository;
import rjw.dc.core.objects.DataCrowObject;
import rjw.dc.resources.DCLabels;
import rjw.dc.util.Resources;
import rjw.flex.settings.Settings;

/**
 * @author rjwaal
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class UpdateAllDialog extends JDialog {
    
    private JButton buttonApply;
    private JButton buttonCancel;
    
    private JLabel[] cLabels;
    private JComponent[] cInputFields;
    
    private DataCrowObject o;
    private boolean success = false;
   
    public UpdateAllDialog(DataCrowObject o, JFrame parent) {
        super(parent);
        setTitle(Resources.getText(DCLabels.lblUpdateAll));
        this.o = o;
        buildDialog(o);
        
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                Settings.setValue(Repository.settings.stUpdateAllDialogSize,
                                  getSize());
                success = false;
                done();
            }
        });

        setModal(true);
        setSize(Settings.getValueAsDimension(
                Repository.settings.stUpdateAllDialogSize));
        setVisible(true);
    }
    
    public boolean isSuccess() {
        return success;   
    }
    
    public Object[] getData() {
        Object[] values = new Object[cInputFields.length];
        values[0] = "";
        for (int i = 1; i < o.getFieldIndices().length; i++) {
            int fieldType = o.getFieldType(i) == ComponentFactory._LONGTEXTFIELD ? 
                                                 ComponentFactory._SHORTTEXTFIELD :
                                                 o.getFieldType(i);
            
            Object value = ComponentFactory.getComponentValue(
                           fieldType, 
                           cInputFields[i]);
            values[i] = value;
        }
        return values;
    }    
    
    private void buildDialog(DataCrowObject o) {
        JPanel panelInput = new JPanel(false);
        panelInput.setLayout(new GridBagLayout());
        JPanel panelActions = new JPanel(false);
        panelActions.setLayout(new GridBagLayout());
        
        cLabels = new JLabel[o.getFieldTypes().length];
        cInputFields = new JComponent[o.getFieldTypes().length];
        
        // Create the input panel
        for (int i = 0; i < o.getFieldTypes().length; i ++) {
            cLabels[i]      = ComponentFactory.getLabel(o.getLabel(i));
            
            int fieldType = o.getFieldType(i);
            if (fieldType == ComponentFactory._LONGTEXTFIELD) {
                fieldType = ComponentFactory._SHORTTEXTFIELD;   
            }
            
            cInputFields[i] = ComponentFactory.getComponent(fieldType, 
                                                                o.getLabel(i),
                                                                o.getMaxFieldLength(i));
            
            panelInput.add(cLabels[i]        , new GridBagConstraints(0, i, 1, 1, 1.0, 1.0
                                             , GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL,
                                               new Insets(0, 5, 0, 5), 0, 0));            
            panelInput.add(cInputFields[i]   , new GridBagConstraints(1, i, 1, 1, 10.0, 10.0
                                             , GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL,
                                               new Insets(0, 5, 0, 5), 0, 0));
        }
        
        // create the action panel
        buttonApply = ComponentFactory.getButton(Resources.getText(DCLabels.lblApply));
        buttonCancel = ComponentFactory.getButton(Resources.getText(DCLabels.lblCancel));
        
        buttonApply.addActionListener(new ApplyAction());
        buttonCancel.addActionListener(new CancelAction());
        
        panelActions.add(buttonApply    , new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                                        , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE,
                                          new Insets(5, 5, 5, 5), 0, 0));            
        panelActions.add(buttonCancel   , new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
                                        , GridBagConstraints.NORTHWEST, GridBagConstraints.NONE,
                                          new Insets(5, 5, 5, 5), 0, 0));
                                          
        // main panel
        this.getContentPane().setLayout(new GridBagLayout());
        this.getContentPane().add(panelInput  ,new GridBagConstraints(0, 0, 1, 1, 10.0, 10.0
                                              ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL,
                                               new Insets(5, 5, 5, 5), 0, 0));
        this.getContentPane().add(panelActions,new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0
                                              ,GridBagConstraints.SOUTHWEST, GridBagConstraints.NONE,
                                               new Insets(5, 5, 5, 5), 0, 0));
        
        pack();
        hideFields(o.getHiddenFields());
    }
    
    private void done() {
        setModal(false);
        setVisible(false);
    }
    
    private void hideFields(int[] indices) {
        cLabels[0].setVisible(false);
        cInputFields[0].setVisible(false);
        for (int i = 0; i < indices.length; i++) {
            cLabels[indices[i]].setVisible(false);
            cInputFields[indices[i]].setVisible(false);
        }
    }  

    private class CancelAction implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            success = false;
            done();
        }
    }
    
    private class ApplyAction implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            success = true;
            done();
        }
    }   
}
