/******************************************************************************
 *                                     __                                     *
 *                              <-----/@@\----->                              *
 *                             <-< <  \\//  > >->                             *
 *                               <-<-\ __ /->->                               *
 *                               Data /  \ Crow                               *
 *                                   ^    ^                                   *
 *                       (c) 2003 Robert-Jan van der Waals                    *
 *                             rwaals@anytimenow.com                          *
 *                                                                            *
 *                                                                            *
 *       This library is free software; you can redistribute it and/or        *
 *        modify it under the terms of the GNU Lesser General Public          *
 *       License as published by the Free Software Foundation; either         *
 *     version 2.1 of the License, or (at your option) any later version.     *
 *                                                                            *
 *      This library is distributed in the hope that it will be useful,       *
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU       *
 *           Lesser General Public License for more details.                  *
 *                                                                            *
 *     You should have received a copy of the GNU Lesser General Public       *
 *    License along with this library; if not, write to the Free Software     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA   *
 *                                                                            *
 ******************************************************************************/

package rjw.dc.util;

import java.util.Calendar;
import java.util.Random;

/**
 * General utilities
 *
 * @author Robert-Jan van der Waals
 * @since 1.3
 * @version DC0.50
 */
public class Utilities {

    private static Random random = new Random();

    public String getUniqueID() {
        
        Calendar calendar = Calendar.getInstance();

        long temp = random.nextLong();
        
        if (temp < 0l) {
            temp = temp * -1;
        }
        
        String month = String.valueOf(calendar.get(Calendar.MONTH));
        if (month.length() == 1) {
            month = "0" + month;
        }
        
        String dayOfMonth = String.valueOf(calendar.get(Calendar.DAY_OF_MONTH));
        if (dayOfMonth.length() == 1) {
            dayOfMonth = "0" + dayOfMonth;
        }

        String sNewID = String.valueOf(calendar.get(Calendar.YEAR)) +
                        month + 
                        dayOfMonth +
        				temp;
                        
        if (sNewID.length() > 15) {
            sNewID = sNewID.substring(0, 14);
        }

        return sNewID;
    }
}
